/**********************************************************
	hw.h
	version 1.1
	YoungMin Kwon (ykwon4@cs.uiuc.edu)
**********************************************************/
#ifndef _HW_H
#define _HW_H

#include "comm.h"
#include "memory.h"

extern int sp[];

extern uint8_t isBeeping;
void startBeeping();
void stopBeeping();

void printmsg(uint16_t args);
int _printmsg(uint16_t args, char *msgbuf, int *msgidx);
void sendPacket(uint8_t *buf, uint8_t n);
void recvPacket();
uint16_t IO(uint16_t a, uint16_t b);
void ledSet(uint16_t n);
void ledToggle(uint16_t n);
uint8_t isRecvPending();
uint8_t isSendPending();
void flashWrite(uint16_t addr, void *p, uint8_t n);
void flashRead(uint16_t addr, void *p, uint8_t n);
uint16_t printlist(uint16_t a);
uint16_t hwId();
void printmsg(uint16_t a);

#endif /* _HW_H */
