/**********************************************************
	init.c
	version 1.1
	YoungMin Kwon (ykwon4@cs.uiuc.edu)
	Kirill Mechitov (mechitov@cs.uiuc.edu)
**********************************************************/
#include "memory.h"
#include "data.h"
#include "eval.h"
#include "comm.h"
#include "thread.h"
#include "hw.h"

#ifndef PC
int _printmsg(uint16_t args, char *msgbuf, int *msgidx) {
	return 0;
}
void printmsg(uint16_t args) {
}
#endif

void init(void *arg) {
	uint16_t pgm, _x, _y, _z;

	//ledSet(1);
	initThread();
	//ledSet(2);
	initVM();
	//ledSet(3);
	initData();
	//ledSet(4);
	initEnv();
	//ledSet(5);
	initComm();
	//ledSet(6);
	//ledSet(7);
#ifndef PC
	ledSet(1);
#endif

	_x=name("x");
	_y=name("y");
	_z=name("z");

	pgm=list(2,
			list(3, sym.rec, list(2, _x, _y),
				list(4, sym.cond, list(3, sym.equal, list(2, sym.cdr, list(1, sym.msgq)), sym.nil),
					list(2, _x, list(1, sym.sleep)),
					list(2, _x,
						list(2,
							list(3, sym.lambda,
								list(1, _z),
								list(3, sym.seq,
									list(3, sym.setcdr, list(1, sym.msgq), list(2, sym.cdr, list(2, sym.cdr, list(1, sym.msgq)))),
									list(2, sym.par,
										list(2, sym.eval, list(2, sym.cdr, _z))
									)
								)
							),
							list(2, sym.car, list(2, sym.cdr, list(1, sym.msgq)))
						)
					)
				)
			),
			sym.nil
		);
	eval(pgm, baseEnv, haltCont(newWord(hwId())));
}
