/**********************************************************
	prim.h
	version 1.1
	Kirill Mechitov (mechitov@cs.uiuc.edu)
**********************************************************/
#ifndef _PRIM_H
#define _PRIM_H

	extern uint8_t isBeeping;

	uint16_t PRIM(uint16_t a, uint16_t b);

	uint16_t detectBeamEvent();					// 1
	uint16_t sortEdges(uint16_t args);			// 2
	uint16_t averagePulsePairs(uint16_t args);	// 3
	uint16_t estimateMotion(uint16_t args);		// 4
	uint16_t classifyVehicle(uint16_t args);	// 5
	uint16_t photoDetect();						// 6
	uint16_t detectShadow();					// 7
	uint16_t beep();							// 8

#endif /* _PRIM_H */
