(	;main function
	(lambda (measure migrate max delay return launch)
		(	(rec (move path temp)
				(seq								;makes move a non-tail recursive func.
					(send (list 0 measure (id)))	;0: broadcast
					(delay 10)						;wait 1 sec
					(	(lambda (maxt)
							(par					;eliminate unnecessary stack of cont.
								(print (car maxt))
								(cond (le (car maxt) temp)		;arrives at an extreme point
									(return migrate path temp)
									(move
										(cond (equal path nil)
											(cons launch path)
											(cons (io 0) path))
										(migrate
											(cadr maxt)
											(car  maxt))))
								(setcdr (msgq) nil)))			;reset msgq
						(max (cdr (msgq)) (list 0 0)))))
			nil 0))

	;measure
	(lambda (ret)	
		(seq
			(print (id))
			(send (list ret (io 0) (io 0)))))	;(io 1): temp, (io 0): h/w-id

	;migrate
	(lambda (adrs val)
		(callcc
			(lambda (cc)
				(send (list adrs cc (list quote val))))))	;quote: to prevent a pair to be applied

	;max
	(rec (max lst t)						;find the max temp. and its location
		(cond (equal lst nil)
			t
			(cond (equal (caar lst) (id))		;(car lst): (self-id, temp, id)
				(cond (gt (cadar lst) (car t))
					(max (cdr lst) (cdar lst))
					(max (cdr lst) t))
				(max (cdr lst) t)))) 

	;delay
	(lambda (t)								;delay up to t over ten sec
		(	(rec (until t)
				(cond (ge (io 3) t)			;(io 3): current tick
					0
					(until t)))
			(add (io 3) t)))

	;return 
	(rec (return migrate path temp)
		(par
			(print (id))
			(cond (equal path nil)
				(print temp)
				(return
					migrate
					(cdr path) 
					(migrate (car path) temp)))))

	;launch
	(car (par
			(	(rec (launch)
					(cond (equal (cdr (msgq)) nil)
						(seq (sleep) (launch))
						(eval (cdadr (msgq))))))))
	)

