/**********************************************************
	packet.h
	version 1.1
	YoungMin Kwon (ykwon4@cs.uiuc.edu)
**********************************************************/

#ifndef _PACKET_H
#define	_PACKET_H

#define PacketHeaderLength	5
#define PacketLength		36	/* header + data + crc */

enum {
	TagData = 1,
	TagAck = 2
};

typedef struct {
	uint8_t adrs[2];
	uint8_t type;
	uint8_t group;
	uint8_t length;
	uint8_t data[29];
	uint16_t crc;
	uint8_t pad[7];
} Msg;

#endif /* _PACKET_H */
